var states =[ 
["Anguilla","imgs/anguilla.png","anguillal"],
["Curaçao (NL)","imgs/antilleol.png","antilleoll"],
["Antigua and Barbuda","imgs/antiguabarbuda.png","antiguabarbudal"],
["Argentina","imgs/argentina.png","argentinal"],
["Aruba","imgs/aruba.png","arubal"],
["Bahamas","imgs/bahamas.png","bahamasl"],
["Barbados","imgs/barbados.png","barbadosl"],
["Belize","imgs/belize.png","belizel"],
["Bermuda","imgs/bermuda.png","bermudal"],
["Bolivia","imgs/bolivia.png","bolivial"],
["Brasil","imgs/brasile.png","brasilel"],
["Canada","imgs/canada.png","canadal"],
["Cayman Islands","imgs/cayman.png","caymanl"],
["Chile","imgs/cile.png","cilel"],
["Colombia","imgs/colombia.png","colombial"],
["Costa Rica","imgs/costarica.png","costarical"],
["Cuba","imgs/cuba.png","cubal"],
["Dominica","imgs/dominica.png","dominical"],
["Ecuador","imgs/ecuador.png","ecuadorl"],
["El Salvador","imgs/elsalvador.png","elsalvadorl"],
["Falkland Islands","imgs/falkland.png","falklandl"],
["Jamaica","imgs/giamaica.png","giamaical"],
["Grenada","imgs/grenada.png","grenadal"],
["Greenland","imgs/groenlandia.png","groenlandial"],
["Guadeloupe (FR)","imgs/guadalupa.png","guadalupal"],
["Guatemala","imgs/guatemala.png","guatemalal"],
["Guyana","imgs/guyana.png","guyanal"],
["French Guyana","imgs/guyanafx.png","guyanafxl"],
["Haiti","imgs/haiti.png","haitil"],
["Honduras","imgs/honduras.png","hondurasl"],
["Martinica","imgs/martinica.png","martinical"],
["Mexico","imgs/messico.png","messicol"],
["Montserrat","imgs/montserrat.png","montserratl"],
["Nicaragua","imgs/nicaragua.png","nicaragual"],
["Panama","imgs/panama.png","anguillal","panamal"],
["Paraguay","imgs/paraguay.png","paraguayl"],
["Perù","imgs/peru.png","perul"],
["Puerto Rico","imgs/portorico.png","portoricol"],
["Dominican Republic","imgs/repdominicana.png","repdominicanal"],
["Saint Kitts and Nevis","imgs/skitts.png","skittsl"],
["Saint Lucia","imgs/slucia.png","slucial"],
["Saint Pierre Miquelon","imgs/spierre.png","spierrel"],
["United States of America","imgs/stuniti.png","stunitil"],
["Suriname","imgs/suriname.png","surinamel"],
["Saint Vincent and Grenadine","imgs/svincent.png","svincentl"],
["Trinidad and Tobago","imgs/trinidad.png","trinidadl"],
["Turks and Caicos","imgs/turkscaicos.png","turkscaicosl"],
["Uruguay","imgs/uruguay.png","uruguayl"],
["Venezuela","imgs/venezuela.png","venezuelal"],
["Us Virgin Islands","imgs/verginia.png","verginial"],
["British Virgin Islands","imgs/verginib.png","verginibl"]];
let indici=[];
for (let i=0; i<states.length; i++)
{	indici[i]=i;
}
function shuffle(array) 
{  let currentIndex = array.length, temporaryValue, randomIndex;
  // While there remain elements to shuffle...
  while (0 !== currentIndex) 
  {  // Pick a remaining element...
    randomIndex = Math.floor(Math.random() * currentIndex);
    currentIndex -= 1;
    // And swap it with the current element.
    temporaryValue = array[currentIndex];
    array[currentIndex] = array[randomIndex];
    array[randomIndex] = temporaryValue;
  }
  return array;
}
let ind=shuffle(indici);
let count=0, corrette=0, errate=0, index=1, end="", punteggio="", bad="";
window.onload = function () 
{  let ImageMap = function (map, img) 
   {  let n, areas = map.getElementsByTagName('area'),
      len = areas.length, coords = [], previousWidth = 823;
      for (n = 0; n < len; n++) 
      { coords[n] = areas[n].coords.split(',');
      }
      this.resize = function () 
      { let n, m, clen,
        x = img.offsetWidth / previousWidth;
        for (n = 0; n < len; n++) 
        { clen = coords[n].length;
          for (m = 0; m < clen; m++) 
          { coords[n][m] *= x;
          }
          areas[n].coords = coords[n].join(',');
        }
        previousWidth = img.offsetWidth;
        return true;
      };
      window.onresize = this.resize;
      map.addEventListener("click",eventClick);
	function eventClick(e)
	{	for(let i=0;i<len;i++)
		{
			if (areas[i]==e.target)
			check(states[i][0]);
		}
	}
    },
    imageMap = new ImageMap(document.getElementById('map'), document.getElementById('m'));
    imageMap.resize();
    document.getElementById('dhead').innerHTML=document.getElementById('dhead').innerHTML+" -- tap "+states[ind[count]][0];
    return;
}
function check(name)
{   let voice =	document.getElementById('dhead');
    let murder = document.getElementById('m');
	let len = states.length;
	for (let i=0; i<len; i++)
    {   document.getElementById(states[i][2]).style.display="none";
    }
    if(index<len)
	{	if(states[ind[count]][0]===name)
		{	murder.setAttribute("src",states[ind[count]][1]);
            document.getElementById(states[ind[count]][2]).style.display="block";
			count++;corrette++;index++;
			voice.innerHTML="ok, now tap "+states[ind[count]][0]+", got "+corrette+"/"+len;	
		}
		else if (states[ind[count]][0]!==name)
		{	errate++;
			voice.innerHTML="keep calm and look for "+states[ind[count]][0]+", got "+corrette+"/"+len;
			bad=bad+" "+states[ind[count]][0]+",";
		} 	
	}
	else if (index==len)
	{	if(states[ind[count]][0]===name)
		{	corrette++;index++;
			voice.innerHTML =	"<button  onclick='javascript:score()'>result</button>"+" "
			+"<button  onclick='javascript:location.reload();'>try again</button>";
			murder.setAttribute("src",states[ind[count]][1]);
		}
		else if (states[ind[count]][0]!==name)
		{	errate++;
			voice.innerHTML="keep calm and look for "+states[ind[count]][0]+", got "+corrette+"/"+len;
			bad=bad+" "+states[ind[count]][0]+",";
		} 
	}
	else if (index>len)
	{	return false;
	}
}
function score()
{	let score=(((corrette-errate)/corrette)*10).toFixed(2);
	if(score<=10 && score>=9)
	{	punteggio="excellent! "+ score+"/10";
	}
	else if(score<9 && score>=8)
	{	punteggio="very good! "+ score+"/10";
	}
	else if(score<8 && score>=7)
	{	punteggio="good! "+ score+"/10";
	}
	else if(score<7 && score>=6)
	{	punteggio="adequate "+ score+"/10";
	}
	else if(score<6)
	{	punteggio="not adequate "+ score+"/10";
	}
	end="<p style='text-align:left'>Test completed:<br>"
	+"- correct: "+corrette+"<br>"
	+"- wrong: "+errate+"<br>" 
	+"- result: "+punteggio+"<br>"
	+"- you didn't find: "+bad.substring(0,bad.length-1)+"<br></p>"
	+"<img src='imgs/americhes.png'>";
	document.getElementById('cdiv').innerHTML=end;
}